<!-- # 请您Star Please Star

如果你觉得此工具不错，请轻轻点击此页面右上角**Star**按钮增加项目曝光度，谢谢！

If you think this tool is good, please gently click the **Star** button in the upper right corner at this page to increase the project exposure, thank you! -->

# EasySpider: Visual Code-Free Web Crawler/Spider

A visual code-free/no-code web crawler/spider, supporting both Chinese and English. 

一个可以无代码可视化设计和执行的爬虫软件，支持中文和英文版本。

## Download EasySpider/下载 EasySpider

Refer to the [Releases Page](https://github.com/NaiboWang/EasySpider/releases) of github to download the latest version of EasySpider.

进入 [Releases Page](https://github.com/NaiboWang/EasySpider/releases) 下载最新版本。


## Video Tutorials/视频教程

Refer to [Youtube Playlist](https://youtube.com/playlist?list=PL0kEFEkWrT7mt9MUlEBV2DTo1QsaanUTp) to see the video tutorials of EasySpider.

## Documentation/文档

Documentation can be found from [Github Wiki](https://github.com/NaiboWang/EasySpider/wiki).

中文文档：请暂时翻译上面的[英文文档](https://github.com/NaiboWang/EasySpider/wiki)，或看作者的[硕士毕业论文](Docs/%E9%9D%A2%E5%90%91WEB%E5%BA%94%E7%94%A8%E7%9A%84%E6%99%BA%E8%83%BD%E5%8C%96%E6%9C%8D%E5%8A%A1%E5%B0%81%E8%A3%85%E7%B3%BB%E7%BB%9F%E8%AE%BE%E8%AE%A1%E4%B8%8E%E5%AE%9E%E7%8E%B0.pdf)（主要看第五章）。

## Publications/出版物

- This software has been accepted by [The Web Conference (WWW) 2023](https://www2023.thewebconf.org/). The paper will be available soon.

- [浙江大学硕士论文](Docs/%E9%9D%A2%E5%90%91WEB%E5%BA%94%E7%94%A8%E7%9A%84%E6%99%BA%E8%83%BD%E5%8C%96%E6%9C%8D%E5%8A%A1%E5%B0%81%E8%A3%85%E7%B3%BB%E7%BB%9F%E8%AE%BE%E8%AE%A1%E4%B8%8E%E5%AE%9E%E7%8E%B0.pdf)，2020年6月。

<!-- - See the [Copyright Declaration Page](https://github.com/NaiboWang/EasySpider/blob/master/media/readme_back.md) here.
 -->

## 中文目录

- [EasySpider: Visual Code-Free Web Crawler/Spider](#easyspider-visual-code-free-web-crawlerspider)
  - [Download EasySpider/下载 EasySpider](#download-easyspider下载-easyspider)
  - [Video Tutorials/视频教程](#video-tutorials视频教程)
  - [Documentation/文档](#documentation文档)
  - [Publications/出版物](#publications出版物)
  - [中文目录](#中文目录)
  - [中文界面截图](#中文界面截图)
      - [软件界面示例](#软件界面示例)
      - [块和子块及表单定义](#块和子块及表单定义)
      - [已选中和待选择示例](#已选中和待选择示例)
      - [京东商品块选择示例：](#京东商品块选择示例)
      - [京东商品标题自动匹配选择示例](#京东商品标题自动匹配选择示例)
      - [分块选择所有子元素示例](#分块选择所有子元素示例)
      - [同类型元素自动和手动匹配示例](#同类型元素自动和手动匹配示例)
      - [四种选择方式示例](#四种选择方式示例)
      - [输入文字示例](#输入文字示例)
      - [循环点击58同城房屋标题以进入详情页采集示例](#循环点击58同城房屋标题以进入详情页采集示例)
      - [采集元素文本示例](#采集元素文本示例)
      - [流程图界面介绍](#流程图界面介绍)
      - [循环选项示例](#循环选项示例)
      - [循环点击下一页示例](#循环点击下一页示例)
      - [条件分支示例](#条件分支示例)
      - [完整采集流程图示例](#完整采集流程图示例)
      - [完整采集流程图转换为常规流程图示例](#完整采集流程图转换为常规流程图示例)
      - [服务信息示例](#服务信息示例)
      - [服务调用示例](#服务调用示例)
      - [58 同城房源信息采集服务部分采集结果展示](#58-同城房源信息采集服务部分采集结果展示)

<!-- END doctoc generated TOC please keep comment here to allow auto update -->

## 中文界面截图

#### 软件界面示例

![pic](media/Picture.png)
#### 块和子块及表单定义

![pic](media/Picture2.png)
#### 已选中和待选择示例

![pic](media/Picture7.png)
#### 京东商品块选择示例：

![pic](media/Picture1.png)


#### 京东商品标题自动匹配选择示例

![pic](media/Picture5.png)
#### 分块选择所有子元素示例

![pic](media/Picture6.png)

#### 同类型元素自动和手动匹配示例

![pic](media/Picture8.png)
#### 四种选择方式示例

![pic](media/Picture90.png)
#### 输入文字示例

![pic](media/Picture10.png)
#### 循环点击58同城房屋标题以进入详情页采集示例

![pic](media/Picture12.png)
#### 采集元素文本示例

![pic](media/Picture14.png)
#### 流程图界面介绍

![pic](media/Picture4.png)
#### 循环选项示例

![pic](media/Picture9.png)

#### 循环点击下一页示例

![pic](media/Picture11.png)

#### 条件分支示例

![pic](media/Picture13.png)
#### 完整采集流程图示例

![pic](media/Picture16.png)
#### 完整采集流程图转换为常规流程图示例

![pic](media/Picture91.png)
#### 服务信息示例

![pic](media/Picture15.png)

#### 服务调用示例

![pic](media/Picture17.png)


#### 58 同城房源信息采集服务部分采集结果展示
![pic](media/Picture18.png)



<!-- ## Ethics Discussion
Various fields can benefit from web crawlers due to their open access nature.
Inevitably, there will be some risk of malicious use or data infringement issue, e.g., automatic order swiping and ticket grabbing, but this is contrary to our expectations. As a tool developer, we only hope that it can be used for legitimate purposes. We advocate the reasonable and legal utilization of our system, respecting and protecting the data security and privacy. -->
